import { handleRedirect } from "./extends";
import { generateHTML } from "./generate";
import { logger } from "./utils";

import type { Page, PluginFunction } from "@vuepress/core";
import type {
  RedirectOptions,
  RedirectPluginFrontmatterOption,
} from "../shared";

export const redirectPlugin =
  (options: RedirectOptions): PluginFunction =>
  (app) => {
    if (app.env.isDebug) logger.info(`Options: ${options.toString()}`);

    return {
      name: "vuepress-plugin-redirect2",

      extendsPage: (page, app) =>
        handleRedirect(
          page as Page<Record<string, never>, RedirectPluginFrontmatterOption>,
          app,
          options
        ),

      onGenerated: (app): Promise<void> => generateHTML(app, options),
    };
  };
